<?php
namespace Models;

class Linesset extends \DB\SQL\Mapper {
	public $db, $f3;

	public function __construct($db, $f3) {
		parent::__construct($db, 'linesset' ); // подключаемся к таблице логов
		$this->db=$db;
		$this->f3=$f3;
	}

	function select_linesset($query=null, $options=null) {
		$linesset=array();
		$this->load($query, $options);
		if($this->dry()) {
			return $linesset;
		}
		do {
			$linesset[]=$this->cast();
		}
		while($this->skip());
		$this->reset();
		return $linesset;
	}

	function get_control($code) {
		$n=mb_strlen($code);
		$sum[0]=0;
		$sum[1]=0;
		for($i=0; $i<$n; $i++) {
			$sum[$i%2]+=$code[$i];
		}
		$sum[1]*=3;
		$summ=$sum[0]+$sum[1];
		$control=10-($summ-floor($summ/10)*10);
		if($control==10) $control=0;
		return $control;
	}

	function save_linesset($txt) {
		$id=0;
		$this->reset();
		$this->load(array('txt=?', $txt), array('limit'=>1));
		if(!$this->dry()) {
			$id=$this->id;
		}
		else {
			$this->txt=$txt;
			if($this->save()===false) {
				return array(
					'success'=>false,
					'txt'=>'db_error'
				);
			}
			$id=$this->get('_id');
			$barcode=$this->f3->get('linesset_pr').sprintf("%'010d", $id);
			$barcode.=$this->get_control($barcode);
			$this->barcode=$barcode;
			if($this->update()===false) {
				return array(
					'success'=>false,
					'txt'=>'db_error'
				);
			}
		}

		return array(
			'success'=>true,
			'txt'=>'save_successful',
			'id'=>$id,
			'barcode'=>$this->barcode
		);
	}
}
